;------------------------------------------
; Solar Assembler test file
;
; test PE64 output with a GUI application
;------------------------------------------
.use64

;---------------
; sections
;---------------
section 	"code" 		class_code
section 	"data" 		class_data
section 	"idata"		class_imports
section		"reloc"		class_relocs

;-------------------------------
; used constants and API names
;-------------------------------
include		../win64_inc.asm


;-----------------
; program text
;-----------------
.data
	module_handle	dq	0
	main_handle	dq	0

	align 16
	wnd_class	rs	WNDCLASS,5

	align 16
	my_ps		rs	PAINTSTRUCT,5

	align 16
	my_msg		rs	MSG,5


	caption		db	"Solar Assembler - Win64 Window Sample",0
	class_name	db	"SOL_Wnd_Class",0


.code

;-----------------
; entry point
;-----------------
.entry Start

Start:
	sub	rsp,8
	
	invoke	GetModuleHandleA,0
	mov	[module_handle],rax

	; clear class structure
	mov	rdi,wnd_class
	mov	rcx,size WNDCLASS
	xor	rax,rax
	rep	stosb

	;--------------------------------
	; fill class structure
	;--------------------------------
	mov	rsi,wnd_class

	mov	rax, Wnd_Proc1
	mov	[rsi + WNDCLASS.wnd_proc_ptr], rax

	mov	rax,[module_handle]
	mov	[rsi + WNDCLASS.instance_handle],rax

	mov	rax, class_name
	mov	[rsi + WNDCLASS.class_name_ptr],rax
	
	; choose background color
	;mov	[rsi + WNDCLASS.back_brush_handle],COLOR_WINDOW+1
	mov	[rsi + WNDCLASS.back_brush_handle],COLOR_BTNFACE+2

	invoke	LoadCursorA,0,IDC_ARROW
	mov	[rsi + WNDCLASS.cursor_handle],rax

	invoke	LoadIconA,0,IDI_APPLICATION
	mov	[rsi + WNDCLASS.icon_handle],rax

	;-----------------------------
	; register class structure
	;-----------------------------
	invoke	RegisterClassA,rsi

	; check for error
	test	eax,eax
	jz	finish

	;-----------------------------
	; create the window
	;-----------------------------
	mov	r8,WS_OVERLAPPED+WS_CAPTION+WS_SYSMENU+WS_THICKFRAME+WS_MINIMIZEBOX+WS_MAXIMIZEBOX

	invoke	CreateWindowExA,0,class_name,caption,r8,32,64,320,240,0,0,[module_handle],0
	mov	[main_handle],rax

	; check for error
	test	eax,eax
	jz	finish

	;----------------------------
	; update window on screen
	;----------------------------
	invoke	ShowWindow,[main_handle],SW_SHOW
	invoke	UpdateWindow,[main_handle]


	;----------------------------
	; enter windows message loop
	;----------------------------

msg_loop:

	invoke	GetMessageA,my_msg,0,0,0

	test	eax,eax
	jz	finish

	cmp	eax,0ffffffffh
	jz	finish

	invoke	TranslateMessage,my_msg
	invoke	DispatchMessageA,my_msg			

	jmp	msg_loop


finish:
	
	invoke	ExitProcess,0
	ret



;------------------------------
; Window callback procedure
;------------------------------
PROC Wnd_Proc1 win64
	USES	rbx,rsi,rdi
	ARG	hwnd, wmsg, wparam, lparam

	;-------------------------
	; spill is usually needed
	;-------------------------
	mov     [hwnd],rcx
	mov     [wmsg],rdx
	mov     [wparam],r8
	mov     [lparam],r9

	; add other message handlers here
	
	mov	rax,[wmsg]
	.IF rax == WM_DESTROY
		invoke	PostQuitMessage,0
		xor	rax,rax
	.ELSE
		;----------------------
		; default handling
		;----------------------
		invoke	DefWindowProcA,[hwnd],[wmsg],[wparam],[lparam]	
	.ENDIF

	ret
ENDP

;------------------------
; end of program text
;------------------------

